CON
	_xinfreq		= 5_000_000			' Quartz is 5MHz
	_clkmode		= xtal1 + pll16x		' System clock is 80MHz

#define DracBladeProp

	SYNC_W			= 7*16
	VIDEO_W			= 384
	VIDEO_H			= 240
	CHAR_W			= 48
	CHAR_H			= 30
	FONT_W			= 8
	FONT_H			= 8
	FRONT_PORCH		= 31
	VSYNC_ROWS		= 2
	BOTTOM_PORCH		= 11

	do_pin			= 15
	clk_pin			= 14
	di_pin			= 13
	cs_pin			= 12

OBJ
	vgavid	: "vgavid"
	vgagen	: "vgagen"
	fdx	: "pcFullDuplexSerial2FC"

VAR
	long	seed
	long	x
	long	y
	long	ch
	long	val

PUB main
	fdx.AddPort(0, 31, 30, -1, -1, 0, 0, 115200)
	fdx.Start
	vgavid.start(@sync, @pixmem0, @colmem0, 16)

	waitcnt(6 * clkfreq + cnt)

	vgagen.start(@sync, @pixmem0, @colmem0)

	seed := 1
	repeat x from 0 to CHAR_W-1
		framebuff[x] := $8700 + $30 + x // 10
	repeat y from 0 to CHAR_H-1
		framebuff[y * CHAR_W] := $8700 + $30 + y // 10
	repeat
		repeat y from 1 to CHAR_H-2
			repeat x from 1 to CHAR_W-1
				framebuff[y * CHAR_W + x] := rnd
				waitcnt(200_000 + cnt)
				if fdx.rxavail(0)
					ch := fdx.rx(0)
					val := long[vgavid.frqa_ptr]
					if ch == "i"
						long[vgavid.frqa_ptr] := val + 1 << 20
					if ch == "d"
						long[vgavid.frqa_ptr] := val - 1 << 20
					hex(val, 8)

PRI hex(value, digits) | xo
	value := value << ((8 - digits) << 2)
	xo := 1
	repeat digits
		framebuff[(CHAR_H-1)*CHAR_W + xo] := $1e00 + lookupz((value <-= 4) & $F : "0".."9", "A".."F")
		xo += 1

PRI rnd
	seed := seed * 1103515245 + 12345 + CNT / 7777
	return seed

DAT
pixmem0		long	$01234567[CHAR_W/2*FONT_H]		' first row of pixels
pixmem1		long	$aa3300ff[CHAR_W/2*FONT_H]		' second row of pixels
pixmem2		long	$aa55aa55[CHAR_W/2*FONT_H]		' second row of pixels
colmem0		long	$13233343[CHAR_W/2]			' first row of colors
colmem1		long	$e3d3c3b3[CHAR_W/2]			' second row of colors
colmem2		long	$03430343[CHAR_W/2]			' second row of colors
sync		long	0
framebuff	word	0[CHAR_W*CHAR_H]
